<?php

namespace GopNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;

class OperatingBudgetParametersController {
    
    protected $service;
    protected $crudService;
    
    public function __construct($connection, $environment, $util, $service, $crudService){
        $this->connection   = $connection;
        $this->environment  = $environment;
        $this->util         = $util;
        $this->service      = $service;
        $this->crudService	= $crudService;
    }
    
    public function operationalItem(Request\DataSet $request, Response $response) {
        $conditions = [];
        $rows = $request->getDataSet()->getRows();
        $operationalItem = $this->crudService->getFilteredDataSet('operationalItem', $conditions)->getRows();
        if(count($operationalItem) == 0){
            $this->insertItems($rows);         
        }
        $data = [];
        $parametersBudgetOperation = $this->service->reciveParametersForBudgetOperation();
        array_push($data, $operationalItem, $parametersBudgetOperation);
        $response->addDataSet(new DataSet("validateOperationalitemsSelect", $data));
    }

    public function insertItems($rows) {
        $this->service->beginTransaction();
        $idCheck = 'S';
        try{
            foreach($rows as $row) {
               switch ($row["value"]) {
                    case 0:
                        $idTipoOrca = "FATURAMENTO";
                        break;
                    case 1:
                        $idTipoOrca = "IMPOSTO";
                        break;
                    case 2:
                        $idTipoOrca = "CONSUMO";
                        break;
                    case 3:
                        $idTipoOrca = "MAOOBRA";
                        break;
                    case 4:
                        $idTipoOrca = "TAXAADM";
                        break;
                    case 5:
                        $idTipoOrca = "DESPMATRIZ";
                        break;
                    case 6:
                        $idTipoOrca = "DESPDIVERSA";
                        break;
                    case 7:
                        $idTipoOrca = "DESPENTRADA";
                        break;
                    case 8:
                        $idTipoOrca = "IMPOSTOARECUPERAR";
                        break;
                    case 9:
                        $idTipoOrca = "IMPOSTOSOBLUCRO";
                        break;
                    case 10:
                        $idTipoOrca = "INVESTIMENTO";
                        break;
                    case 11:
                        $idTipoOrca = "DEPRECIACAO";
                        break;
                }
                $params = [
                    "NRITEMOPERACIONAL"   => $row["value"],
                    "IDCHECK"             => $idCheck,
                    "IDTIPOORCAOP"        => $idTipoOrca
                ];
                $this->service->insertOperationalItem($params); 
            }
            $this->service->commit();
        }catch(Exception $e) {
            $this->service->rollback();
            throw $e;
        }
    }
}