import Vue from 'vue';
import { ZdFieldGroup } from '@zeedhi/zd-field-group';
import {
  Http,
  Metadata,
} from '@zeedhi/core';
import {
  SelectMultiple,
  Select,
  Form,
  Checkbox,
} from '@zeedhi/common';

Vue.component('ZdFieldGroup', ZdFieldGroup);

export class OperatingBudgetParametersController {
  public checkBoxValue: boolean = true;
  
  public generalDisableField: boolean = true;
  
  public checkInvalue() {
    this.checkBoxValue = !this.checkBoxValue;
    return this.checkBoxValue;
  }
  
  public generalFieldControll() {
    this.generalDisableField = !this.generalDisableField;
    return this.generalDisableField;
  }
  
  public validateOperationalitemsSelect() {
    const arrayValue = [];
    const operationalItem = Metadata.getInstance<SelectMultiple>('OperationalitemsSelect');
    Http.post('/operationalItem', {
      requestType: 'DataSet',
      dataset: operationalItem.datasource.data,
    }).then((response) => {
      const data = response.data.dataset.validateOperationalitemsSelect;
      this.reciveBudgetOperation(data[1][0]);
      data[1].forEach((row) => {
        arrayValue.push(row.NRITEMOPERACIONAL);
      });
      operationalItem.setValue(arrayValue);
    });
  }
  
  public reciveBudgetOperation(data) {
    const formProfile = Metadata.getInstance<Form>('formBillingCalculation');
    formProfile.getChildInstance<Select>('selectBillingCalculation').setValue(data.IDCALCFATUROP);
  }
}
