import { AlertService, DialogService } from '@zeedhi/common';

export class Utilities {
  successMessage(words: string = null): any {
    return AlertService.show({
      name: 'save',
      text: words ?? 'Operação realizada com sucesso',
      color: 'success',
      right: true,
      top: true,
      showDismiss: true,
    });
  }
  
  errorMessage(words: string = null): any {
    AlertService.show({
      name: 'save',
      text: words ?? 'Falha na realização da operação',
      color: 'error',
      right: true,
      top: true,
      showDismiss: true,
    });
  }
  
  warningMessage(words: string): any {
    AlertService.show({
      name: 'save',
      text: words,
      color: 'warning',
      right: true,
      top: true,
      showDismiss: true,
    });
  }
  
  public showDialog(actionConfirmed, data, type) {
    if (type === 'YN') {
      DialogService.show(this.createConfirmationDialog(actionConfirmed, data));
    } else {
      DialogService.show({
        name: 'observationDialogue',
        title: data.TITLE,
        text: data.MESSAGE,
        buttons: [
          {
            name: 'ok',
            component: 'ZdButton',
            label: 'OK',
            events: {
              click: () => DialogService.hide(),
            },
          },
        ],
      });
    }
  }
  
  public createConfirmationDialog(actionConfirmed, data) {
    return {
      name: 'buttons-dialog',
      type: 'warning',
      title: 'Confirmar Operação?',
      text: data.MESSAGE,
      buttons: [
        {
          name: 'noConfirmation',
          component: 'ZdButton',
          label: 'Não',
          events: this.leaveDialogue,
          outline: true,
        },
        {
          name: 'yesConfirmation',
          component: 'ZdButton',
          label: 'Sim',
          events: {
            click: () => actionConfirmed(data),
          },
        },
      ],
    };
  }
  
  public leaveDialogue: any = {
    click: () => DialogService.hide(),
  };
  
  public hideDialogue() {
    DialogService.hide();
  }
}
